
import requests
from pandas.io.json import json_normalize
import pandas as pd
import os,datetime,json
import numpy as np

print
print '----Accessing CDS API metadata----'
print

cds_url = 'https://cds.climate.copernicus.eu/api/v2.ui/resources'
response1 = requests.get(cds_url).json()

response_lvl1 = []
for item in response1:
    response_lvl1.append(cds_url+'/'+str(item))

response_lvl2 = []
for item in response_lvl1:
    response2 = requests.get(item).json()
    response_lvl2.append(response2)

counter = 0
dict_cds = []
for item in response_lvl2:
    dict_ele = {}
    if 'form' in item and item['form']!=None:
        dict_ele.update({'dataset':str(item['name'])})
        for om in item['structured_data']['keywords']:
            if 'Product type' in om:
                a = [str(e).strip() for e in om.split(':')]
                dict_ele.update({a[0]:a[1]})
        for it in item['form']:
            if 'values' in it['details']:
                dict_ele.update({str(it['name']):[str(e) for e in it['details']['values']]})
            elif 'groups' in it['details']:
                guagua = []
                for ete in it['details']['groups']:
                    guagua += ete['values']
                dict_ele.update({str(it['name']):[str(e) for e in guagua]})
    else:
        dict_ele = item
    dict_cds.append(dict_ele)
    counter += 1

for item in dict_cds:
    print
    print '------------------------------------------'
    if 'dataset' in item.keys():
        print item['dataset']
        print item.keys()
        print
    else:
        print item['name']
        print 'Attributes: ',item['form']
        print 'Downloadable: ',item['downloadable']
        print 'Form: ',item['form']

print
print 'Saving as JSON file'
print
filename = 'cds_metadata.json'
with open(filename, 'w') as fout:
    counter = -1
    for item in dict_cds:
        counter += 1
        js = json.dumps(item)
        if counter != len(dict_cds)-1:
            fout.write(js+',\n')
        else:
            fout.write(js+'\n')
fout.close()
print
print '----FINISHED----'
print